/*
 * Author: Nigel Kukard  <nkukard@lbsd.net>
 * Desc: Header file for our curses stuff
 * Date: 29/05/2003
 */


#ifndef _IDMS_CURSES_H
#define _IDMS_CURSES_H

#define setTextAttr(window,mask) wbkgdset(window,WA_NORMAL ^ (mask));


// Function to title a window with text
void windowTitle(WINDOW *win, int color1, int color2, int y, int x, char *str);
// Create a panel with specific attribs
WINDOW *mkwindow(int color, int rows, int cols, int tly, int tlx);
// Create a panel with specific attribs
PANEL *mkpanel(int color, int rows, int cols, int tly, int tlx);
// Function to fill a window
void fill_window(WINDOW *win);
// Function to fill a panel
void fill_panel(PANEL *pan);
// Nice small menu driver
int menu_virtualize(int c);

bool outs(char *s);
// Function to clean ncurses stuff up
void cleanup();

	
#endif

