/*
 * Author: Nigel Kukard  <nkukard@lbsd.net>
 * Desc: IPQ header file for bwmd
 * Date: 15/04/2003
 * License: GPL
*/


#ifndef _IPQ_H
#define _IPQ_H

#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <netinet/ip_icmp.h>
#include <glib.h>
#include "common.h"
#include "libipq.h"


#define IPQ_BUFSIZE 4096
#define IP_PACKET_SIZE 20

struct addr_t
{
	u_int8_t a;
	u_int8_t b;
	u_int8_t c;
	u_int8_t d;
};

// Hijacked out of /usr/include/netinet/ip.h
struct ip_packet_t
{
#if __BYTE_ORDER == __LITTLE_ENDIAN
	unsigned int ihl:4;
	unsigned int version:4;
#elif __BYTE_ORDER == __BIG_ENDIAN
	unsigned int version:4;
	unsigned int ihl:4;
#else
# error	"Please fix <bits/endian.h>"
#endif
	u_int8_t tos;
	u_int16_t tot_len;
	u_int16_t id;
	u_int16_t frag_off;
	u_int8_t ttl;
	u_int8_t protocol;
	u_int16_t check;
	union {
		u_int32_t raw;
		struct addr_t addr;
	} u_saddr;
	
	union {
		u_int32_t raw;
		struct addr_t addr;
	} u_daddr;
};


// Main IPQ->QUEUE thread
void *IPQRunner(void *data);


#endif
