/*
 * Author: Nigel Kukard  <nkukard@lbsd.net>
 * Desc: Reporting header file for bwmd
 * Date: 25/04/2003
 * License: GPL
*/


#ifndef _REPORT_H
#define _REPORT_H

#include "common.h"


#define SECS_PER_HOUR 3600
#define SECS_PER_DAY 86400
#define SECS_PER_WEEK 604800

#define FILE_VER_LEN 20

#define FILE_VER_CURRENT FILE_VER_0_2
#define FILE_VER_0_2 "BWM_VER-0.2"


// File format stuff...
struct aLogFileHeader_t
{
	char fileVer[FILE_VER_LEN];  // File version
	char ref[MAX_REFLEN];  // Client reference number/string
	long int start;  // Start of file in unix timestamp form
	long int end;  // End of file in unix timestamp form
	long int recs;  // Number of records in the file excluding the header
	int counterTimeout;  // Stepping of counter, ie. how many seconds between writes
};

// File record stuff
struct aLogFileEntry_t
{
	long int unixStampStart;
	long int unixStampEnd;
	int entryType;
	long int bytesSeen;
	long int packetsSeen;
	long int packetsBursted;
	long int packetsDropped;
};

// Function passed structure for logging
struct reportData_t
{
	char ref[MAX_REFLEN];
	int counterTimeout;
	struct aLogFileEntry_t entry;
};



// Main reporting module
void *reportRunner(void *data);

#endif

