/*
 * Author: Nigel Kukard  <nkukard@lbsd.net>
 * Desc: Header stuff for our xml config library
 * Date: 05/05/2003
 * License: GPL
*/

#ifndef _XMLCONF_H
#define _XMLCONF_H

#include <glib.h>


// An address declaration with all its lil params
struct confClassAddress_t
{
	char *name;
	GHashTable *params;
};

// The main class with all its' addresses
struct confClass_t
{
	char *name;  // Mandatory
	GList *addresses;  // Address item (unparsed)
	GList *ruleset;  // TODO - Parsed list of rules
};


// An ACL list item...
struct confACLTable_t
{
	char *name;  // Mandatory
	GHashTable *chains;  // Chains associated with this table, indexed by chain name
//	GList *ruleset; // TODO - Parsed ruleList items, this is an "array" of char* 's
};

// a chain entry
struct confACLChain_t
{
	char *name; // Mandatory
	char *defaultTarget;  // Optional default target specifier
	GList *ruleList;
	GList *ruleset; // TODO - Parsed ruleList items, this is an "array" of char* 's
};

// a chain rule
struct confACLRule_t
{
	GList *classList; //  Pointless to be NULL - List of classes we using (their NAMES!)
	GHashTable *params;  // What will we do with no params??
	char *target;  // Mandatory - Target of those classes
};


GHashTable *getModuleLoadHash(char *filename);
GList *createFirewallRules(char *filename);
struct flowData_t createFlowData(char *filename);

#endif
