/*
 * Author: Nigel Kukard  <nkukard@lbsd.net>
 * Desc: Automatic packet priority classification
 * Date: 29/08/2003
 * License: GPL
*/

#include "autoclass.h"


// Band calculation functions, tcp
long int tcpPortToBand(long int bandNum, u_int16_t port)
{
	long int ret = bandNum;
		
		
	// Decide band to pump packet into	
	switch (port)
	{
		// AUTH
		case 113:
			ret = 20;
			break;
		// SSH
		case 22:
		// TELNET
		case 23:
			ret = 25;
			break;
		// HTTP
		case 80:
		// PROXY?
		case 8080:
		case 3128:
		case 3130:
		// HTTPS
		case 443:
			ret = 65;
			break;
		// CVS
		case 2401:
			ret = 70;
			break;
		// POP3
		case 110:
		// IMAP
		case 143:
			ret = 75;
			break;
		// FTP
		case 20:
		case 21:
			ret = 80;
			break;
	};

	return ret;
}
	
// Band calculation functions, udp
long int udpPortToBand(long int bandNum, u_int16_t port)
{
	long int ret = bandNum;
	
	
	// Decide band to pump packet into	
	switch (port)
	{
		// DNS
		case 53:
			ret = 10;
			break;
		// NTP
		case 123:
			ret = 15;
			break;
		// RADIUS
		case 1645:
		case 1646:
		case 1812:
		case 1813:
			ret = 30;
			break;
	};
	
	if (port >= 33434 && port <= 33465)
		ret = 5;
	
	return ret;
}

